#ifndef __CALLBACKS_H_
#define __CALLBACKS_H_

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

void
menu_new_clicked                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
menu_quit_clicked                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
menu_cut_clicked                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
menu_copy_clicked                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
menu_paste_clicked                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
menu_delete_clicked                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
menu_about_clicked                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void tool_group_clicked (GtkToolButton* toolbutton, gpointer user_data);
void tool_grid_toggled (GtkToggleToolButton *toolbutton, gpointer user_data);
void tool_toggled (GtkToolButton *toolbutton, gpointer user_data);

gboolean
canvas_expose                          (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

gboolean
canvas_configure                       (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data);

gboolean
canvas_mouse_down                      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean
canvas_mouse_up                        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

gboolean canvas_mouse_move (GtkWidget *widget, GdkEventMotion *event, gpointer user_data);

void tool_color_set (GtkColorButton*, gpointer);
void tool_font_set (GtkColorButton*, gpointer);
void zoom_clicked (GtkToolButton*, gpointer);
void spin_width_change (GtkSpinButton*, gpointer);
gboolean scroll_change (GtkRange*, GtkScrollType, gdouble, gpointer);

void toggle_filled (gboolean active);
void toggle_dashed (gboolean active);


/* funkce testuje, jestli posledni zadany objekt ma dostatecny pocet vrcholu a pokud ne, tak ho odebere */
void check_elem_completion ();
/* zrusi priznak "vybran" vsem elementum */
void unselect_all ();

#ifdef __cplusplus
}	/* extern "C" */
#endif

#endif
