#ifndef __GLOBALS_H__
#define __GLOBALS_H__

#ifndef NULL
#define NULL 0x00
#endif

#ifndef INFINITY
extern double double_zero_zero;
#define INFINITY (1.0 / double_zero_zero)
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define APP_NAME "GVec"
#define APP_VERSION "0.1.0"
#define APP_YEAR "May 26 2006"
#define APP_AUTHORS "Jan Skalicky (skalij2@fel.cvut.cz), Filip Simek (simekf1@fel.cvut.cz)"
#define APP_COMMENTS "GVec is a simple vector drawing program made by two students of FEE CTU Prague as a homework."
	
/* ruzne rezimy mysiho kurzoru */
#define N_TOGGLE_BUTTONS 11
enum {
	POINTER_SELECT=0,
	POINTER_LINE=1,
	POINTER_MULTILINE=2,
	POINTER_TRIANGLE=3,
	POINTER_RECTANGLE=4,
	POINTER_ELLIPSE=5,
	POINTER_ARC=6,
	POINTER_POLYGON=7,
	POINTER_BEZLINE=8,
	POINTER_TEXT=9,
	POINTER_MOVE=10
};
extern int pointer;		/* typ aktualniho mysiho ukazovatka */
extern int can_width, can_height;	/* rozmery kreslici plochy */
extern int snap_to_grid;	/* promenna urcujici, jestli se vrcholy maji primykat k vrcholum mrizky */
extern double zoom;		/* uroven priblizeni (zoomu) 1.0 je bez zoomu, 2.0 je 200% atd. */
/*extern double scb[];*/	/* hodnoty min. a max. horizontalniho a vertikalniho scrollbaru */
extern double scroll[2];	/* aktualni hodnoty horizontalniho a vertikalniho posuvniku */
extern int min_points[];	/* minimalni pocet vrcholu pro kazdy graficky element */

/* vychozi roztec bodu mrizky v pixelech, pri zoomu 1:1 */
#define GRID_SPAN 16
/* tolerance kvadratu vzdalenosti */
#define THRESHOLD_SELECT_QUADR 100.0
#define THRESHOLD_CLICK_QUADR 9.0
/* #define DEFAULT_FONT "Bitstream Vera Serif Bold" */
/* minimalni a maximalni hodnota pro posuvniky */
#define RANGE_MIN -1500.0
#define RANGE_MAX 1500.0

extern void error( int error_type, char *error_file, int error_line );
#define ERROR_DEFAULT_MSG "unspecified failure"
#define ERROR_DEFAULT_CODE 255
#define ERROR_MALLOC 1
#define ERROR_MALLOC_MSG "malloc() couln't be satisfied"
#define ERROR_MALLOC_CODE 3
#define ERROR_NEW 2
#define ERROR_NEW_MSG "operator new couln't be satisfied"
#define ERROR_NEW_CODE 3

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* _GLOBALS_H */
