/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <vector>

#include <stdlib.h>
#include <gtk/gtk.h>

#include "globals.h"
#include "CElem.hpp"
#include "interface.h"
#include "support.h"

using namespace std;

double double_zero_zero = 0.0;   /* floating zero to produce INFINITY if it's not defined */

/* globalni promenne pro interface */
int snap_to_grid = 1;			/* umistovat vrcholy na mrizku nebo ne? */
GtkWidget *togbut[N_TOGGLE_BUTTONS];	/* prepinaci tlacitka pro jednotlive typy mysiho kurzoru */
gulong toghandlers[N_TOGGLE_BUTTONS];	/* cisla handleru signalu tlacitek */
int pointer=POINTER_SELECT;		/* aktualni typ mysiho kurzoru */
int can_width;				/* rozmery pracovni plochy */
int can_height;
double zoom=1.0;			/* uroven priblizeni (zoomu) 1.0 je bez zoomu, 2.0 je 200% atd. */
/*double scb[4];*/				/* hodnoty min. a max. horizontalniho a vertikalniho scrollbaru */
double scroll[2];			/* aktualni hodnoty horizontalniho a vertikalniho posuvniku */
int min_points[N_TOGGLE_BUTTONS];	/* minimalni pocet vrcholu pro kazdy graficky element */

/* globalni promenne grafickych elementu */
vector<CElem*> elems;

/* entry point */
int main (int argc, char *argv[])
{
  GtkWidget *main_window;

  printf (APP_NAME " " APP_VERSION ", " APP_YEAR "\n  " APP_AUTHORS "\n");
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  	/* minimalni pocty vrcholu pro jednotlive graficke elementy */
	min_points[POINTER_SELECT] = 0;
	min_points[POINTER_MOVE] = 0;
	min_points[POINTER_LINE] = 2;
	min_points[POINTER_MULTILINE] = 2;
	min_points[POINTER_TRIANGLE] = 3;
	min_points[POINTER_RECTANGLE] = 2;
	min_points[POINTER_ELLIPSE] = 2;
	min_points[POINTER_ARC] = 3;
	min_points[POINTER_POLYGON] = 3;
	min_points[POINTER_BEZLINE] = 4;
	min_points[POINTER_TEXT] = 1;

  gtk_set_locale ();
  gtk_init (&argc, &argv);

//  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
  add_pixmap_directory ("./res");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  main_window = create_main_window ();
  gtk_widget_show (main_window);

  gtk_main ();
  return 0;
}

void error( int error_type, char *error_file, int error_line )
 {
	char *error_msg;
	int error_code;

	switch( error_type )
	 {
	  case ERROR_MALLOC:
		error_msg  = ERROR_MALLOC_MSG;
		error_code = ERROR_MALLOC_CODE;
		break;
	  case ERROR_NEW:
		error_msg  = ERROR_NEW_MSG;
		error_code = ERROR_NEW_CODE;
		break;
	  default:
		error_msg  = ERROR_DEFAULT_MSG;
		error_code = ERROR_DEFAULT_CODE;
		break;
	 }
	fprintf( stderr, "error: %s in file: %s, line: %d\n",
	         error_msg, error_file, error_line );
	exit( error_code );
	return;
 }

