#ifndef __PAINT_H_
#define __PAINT_H_

#ifdef __cplusplus
extern "C" {
#endif

/* mozne hodnoty pro parametr dash */
enum {
	DASH_DASHED,
	DASH_SOLID
};

/* tloustky pisma */
enum {
	WEIGHT_LIGHT = 300,
	WEIGHT_NORMAL = 400,
	WEIGHT_BOLD = 700
};

#define PAINT_PT_WIDTH 4

struct point_s {
	double x;
	double y;
};

/* prepocet logickych souradnic na souradnice v bitmape. bere v potaz zoom i posunuti scrollbaru */
void world_to_picture (double in_x, double in_y, int *out_x, int *out_y);
void picture_to_world (int in_x, int in_y, double *out_x, double *out_y);
void snapToGrid(double in_x, double in_y, double *out_x, double *out_y);
/* TODO: funkce pro vypocet tloustky cary a velikosti a tloustky pisma v zavislosti na zoomu */


/* prekresleni okna */
void repaint();
/* vymazani bufferu a nakresleni mrizky */
void draw_grid ();
/* nakresleni zvyraznenych bodu */
void draw_points (struct point_s pts[], int pt_count, unsigned short r, unsigned short g, unsigned short b);
#define draw_hilighted_points(pts, count) draw_points(pts, count, 10000,55000,10000)
#define draw_hilighted_grouppoints(pts, count) draw_points(pts, count, 19200,34816,51968)
/* nakresleni cary */
void draw_line (double x1, double y1, double x2, double y2, unsigned short r, unsigned short g, unsigned short b, int thickness, int dash);
/* nakresleni multicary, pole pts ma rozmer [pt_count][2] (pocet bodu a pro kazdy bod souradnice x,y) */
void draw_multiline (struct point_s pts[], int pt_count, unsigned short r, unsigned short g, unsigned short b, int thickness, int dash);
/* nakresleni polygonu, pole pts ma rozmer [pt_count][2], parametry thickness a dash se vztahuji na obvodovou linku polygonu
 * barva bg_* ma smysl jenom kdyz filled je nenula */
void draw_polygon (struct point_s pts[], int pt_count, unsigned short bg_r, unsigned short bg_g, unsigned short bg_b, unsigned short border_r,
	       	unsigned short border_g, unsigned short border_b, int thickness, int dash, int filled);
/* nakresleni eliptickeho oblouku, zadaneho stredem a horizontalnim a vertikalnim polomerem. uhly jsou ve stupnich */
void draw_arch (double cent_x, double cent_y, double rad_h, double rad_v, double angle_start, double angle_stop,
		unsigned short bg_r, unsigned short bg_g, unsigned short bg_b, unsigned short border_r, unsigned short border_g, unsigned short border_b,
		int thickness, int dash, int filled);
/* nakresleni elipsy zadane stredem a horizontalnim a vertikalnim polomerem */
void draw_ellipse (double cent_x, double cent_y, double rad_h, double rad_v, unsigned short bg_r, unsigned short bg_g,
		unsigned short bg_b, unsigned short border_r, unsigned short border_g, unsigned short border_b, int thickness, int dash, int filled);
/* napsani textu, text je C-style ASCIIZ */
void draw_text (double topleft_x, double topleft_y, char* text, int size, int weight, unsigned short r, unsigned short g, unsigned short b, char *family);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
